<?php
/*************************
  Coppermine Photo Gallery
  ************************
  Copyright (c) 2003-2009 Coppermine Dev Team
  v1.1 originally written by Gregory DEMAR

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License version 3
  as published by the Free Software Foundation.
  
  ********************************************
  Coppermine version: 1.4.20
  $HeadURL: https://coppermine.svn.sourceforge.net/svnroot/coppermine/trunk/cpg1.4.x/include/exif_php.inc.php $
  $Revision: 5705 $
  $Author: gaugau $
  $Date: 2009-01-28 10:52:43 +0100 (Mi, 28 Jan 2009) $
**********************************************/



if (!defined('IN_COPPERMINE')) die('Not in Coppermine...');

define("EXIF_CACHE_FILE","exif.dat");
require("include/exif.php");


function exif_parse_file($filename)
{
        global $CONFIG, $lang_picinfo;
	require("include/exif_tags.inc.php");	//String containing all the available exif tags.
        
	// moved to exif_tags.inc.php
	
        if (!is_readable($filename)) return false;

        $size = @getimagesize($filename);
        if ($size[2] != 2) return false; // Not a JPEG file

        $exifRawData = explode ("|",$exif_info);
        $exifCurrentData = explode("|",$CONFIG['show_which_exif']);

        //Let's build the string of current exif values to be shown
        $showExifStr = "";
        foreach ($exifRawData as $key => $val) {
	//echo $key.':'.$val.':'.$exifCurrentData[$key].'<br>';
          if ($exifCurrentData[$key] == 1) {
            $showExifStr .= "|".$val;
          }
        }
	$showExifStr .= "|";
	
	//echo $showExifStr.'<br>';
        //Check if we have the data of the said file in the table
        $sql = "SELECT * FROM {$CONFIG['TABLE_EXIF']} ".
                  "WHERE filename='".addslashes($filename)."'";

        $result = cpg_db_query($sql);

        if (mysql_num_rows($result) > 0){
                $row = mysql_fetch_array($result);
                mysql_free_result($result);
                $exifRawData = unserialize($row["exifData"]);
        } else {
          // No data in the table - read it from the image file
          $exifRawData = read_exif_data_raw($filename,0);			//exif.php
          // Insert it into table for future reference
          $sql = "INSERT INTO {$CONFIG['TABLE_EXIF']} ".
                    "VALUES ('".addslashes($filename)."', '".addslashes(serialize($exifRawData))."')";
          $result = cpg_db_query($sql);
        }

        $exif = array();

        if (is_array($exifRawData['IFD0'])) {
          $exif = array_merge ($exif,$exifRawData['IFD0']);
        }
        if (is_array($exifRawData['SubIFD'])) {
          $exif = array_merge ($exif, $exifRawData['SubIFD']);
        }
	if (is_array($exifRawData['SubIFD']['MakerNote'])) {
          $exif = array_merge ($exif, $exifRawData['SubIFD']['MakerNote']);
        }
	if (is_array($exifRawData['SubIFD']['MakerNote']['Settings 1'])) {
          $exif = array_merge ($exif, $exifRawData['SubIFD']['MakerNote']['Settings 1']);
        }
	//var_dump($exif);
        $exif['IFD1OffSet'] = $exifRawData['IFD1OffSet'];

        $exifParsed = array();
	$exifSortValue = array();
	$exifSortKey = array();
	$exifNew = array();
	
	foreach ($exif as $key => $val) {	// exif-data
		$pos = strpos($showExifStr,"|".$key);
		if (strpos($showExifStr,"|".$key.'|') && isset($lang_picinfo[$key])){
		//echo $pos.':'.$key.':'.$val.'<br>';
			if(isset($lang_picinfo[$val])){
				$exifParsed[$lang_picinfo[$key]] = $lang_picinfo[$val];
				$exifSortValue[$pos] = $exifParsed[$lang_picinfo[$key]];
				$exifSortKey[$pos] = $lang_picinfo[$key];
			}
			else{
				$exifParsed[$lang_picinfo[$key]] = $val;
				$exifSortValue[$pos] = $val;
				$exifSortKey[$pos] = $lang_picinfo[$key];
			}
		}
	}
	
	ksort($exifSortValue);
	ksort($exifSortKey);
	//var_dump($exifSortKey);
	//var_dump($exifSortValue);
	$exifNew = array_combine($exifSortKey, $exifSortValue);
	
        return $exifNew;
}
?>
